using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Sales.DeliveryOrder.Cqrs;

public record DeleteDeliveryOrderItemCommand(string Id) : IRequest<bool>;

public class DeleteDeliveryOrderItemHandler : IRequestHandler<DeleteDeliveryOrderItemCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteDeliveryOrderItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteDeliveryOrderItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.InventoryTransaction.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}